﻿<#	
	.NOTES
	===========================================================================
	 Created with: 	SAPIEN Technologies, Inc., PowerShell Studio 2016 v5.2.127
	 Created on:   	25/08/2016 10:44
	 Created by:   	Jean-Yves Moschetto
	 Organization: 	CARIB INFRA - YOURSYSTEMS
	 Filename:     	
	===========================================================================
	.DESCRIPTION
		A description of the file.
#>
cd 'C:\Program Files\WindowsPowerShell\Modules\myActiveDirectory\1.1.0.0\Test'
$Credential = Get-Credential "MYDOM\administrator"
Import-Module '..\DSCResources\myAdHelper.psm1' -Verbose -Force
Import-Module '..\DSCResources\myAdWaitForObject\myAdWaitForObject.psm1' -Verbose -Force

$Server = '10.65.0.10'
$RetryCount = 10
$RetryIntervalSec = 3
$Identity = 'CN=10.65.1.0/24,CN=Subnets,CN=Sites,%%configuration%%'

$myParams = @{
	Identity = $Identity
	Server= $Server
	RetryCount = $RetryCount
	RetryIntervalSec = $RetryIntervalSec
	Credential = $Credential
}

Get-TargetResource @myParams -verbose
Test-TargetResource @myParams -verbose
Set-TargetResource @myParams -verbose

$ConfigurationData = @{
	AllNodes = @(
		@{
			NodeName = "*"
			PSDscAllowPlainTextPassword = $true
		}
		@{
			NodeName = "localhost"
		}
	)
}

Configuration Test_myAdWaitForObject
{
	Import-DscResource -ModuleName myActiveDirectory
	
	Node $AllNodes.NodeName
	{
		LocalConfigurationManager
		{
			DebugMode = 'All'
		}
		
		myAdWaitForObject [String] #ResourceName
		{
			Identity = "CN=10.2.168.0/24,CN=Subnets,CN=Sites,%%configuration%%"
			Credential = $Credential
			RetryCount = 600
			RetryIntervalSec = 60
			Server = 'MSNOCDCM0001.minusma-secnet.org'
		}
		
	}
}

Test_myAdWaitForObject -ConfigurationData $configurationData -Verbose -OutputPath "C:\_Tests\Test_myAdWaitForObject"
Start-DscConfiguration -Wait -Force -Verbose -Path "C:\_Tests\Test_myAdWaitForObject"